module AdminAPI
  class Admin
    @@routes = nil
    attr_accessor :inheritance_class
    def initializer
      @inheritance_class = nil
    end
    def register _class, &block
      @inheritance_class = Class.new Admin::AdminController
      Admin::AdminController.const_set "AdminAPI#{_class.name}", @inheritance_class
      yield self
      save_routes
    end
    def controller &block
      #define new route
      yield(@inheritance_class)
    end
    def save_routes
      @inheritance_class.methods.each do
        #Will be configuered later for the rest of the application
      end
    end
    def self.routes
      #Define routes to our controller
      return @@routes
    end
    def config
      yield(self.config)
    end
    private
      def complete_serializer serializer
        @inheritance_class.complete_serializer = serializer
      end
      def short_serializer serializer
        @inheritance_class.short_serializer = serializer
      end
      def permit_params *attributes
        @inheritance_class.permit_params = *attributes
      end
  end
  class AdminController < ApiController
    before_action :authenticate_admin_user!
    attr_accessor :class_name, :short_serializer, :complete_serializer, :permit_params
    def create
      item = @class.new create_params
      if @complete_serializer
        render json: item, serializer: @complete_serializer
      else
        render json:item
      end
    end
    def index
      if @short_serializer
        render json: @class_name.all, each_serializer: @short_serializer
      else
        render json: @class.all
      end
    end
    def update
      item = @class.find params[:id]
      if item.update(create_params)
        if @complete_serializer
          render json: item, serializer: @complete_serializer
        else
          render json:item
        end
      else
        render json: item.errors, status: :bad_request
      end
    end
    def destroy
      @class_name.where(id: params[:id]).destroy_all
      render nothing: true
    end
    private
      def create_params
        params.require(@class.name).permit(@permit_params)
      end
  end
end
